/*
 Copyright (C)2004 Dimax ( http://www.xdimax.com )

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
*/
  
/*
*-------------------------------------------------------------------
* Description: functional tester for i2cbrdg library 
*-------------------------------------------------------------------								 
* Version: $Id: func_test.c,v 1.1 2005/01/21 17:08:25 xol Exp $									   
*-------------------------------------------------------------------
*/
#include <stdio.h>
#include <i2cbrdg.h>

//-----------------------------------------------------------------------------
// Constants
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Global Variables
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Local Function Definition
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// MAIN
//-----------------------------------------------------------------------------
int main( int argc, char* argv[] )
{
    int     rc=0;
    HANDLE  hDevice;
    long    sn;
    U2C_VERSION_INFO fwVersion;
    BYTE    freq, prev_freq;

    // Enumerate 
    rc = U2C_GetDeviceCount();
    printf( "U2C_GetDeviceCount: found %d Dimax u2c-11 device(s)\n", rc );
    if( rc == 0 )
        return -1;

    // Open device '0' 
    hDevice = U2C_OpenDevice( 0 );
    if( hDevice == INVALID_HANDLE_VALUE )
       return -1; 
    printf( "U2C_OpenDevice(0): hDevice=%p\n", hDevice );        

    // Get Serial Number
    rc = U2C_GetSerialNum( hDevice, &sn );
    if( rc ) return rc;
    printf( "U2C_GetSerialNum: %08lx\n", sn );

    // Get FW Version
    rc = U2C_GetFirmwareVersion( hDevice, &fwVersion);
    if( rc ) return rc;
    printf( "U2C_GetFirmwareVersion: Major=%02hd Minor=%02hd\n", 
                            fwVersion.MajorVersion, fwVersion.MinorVersion );

    // I2C Frequency
    rc = U2C_GetI2cFreq( hDevice, &freq );
    if( rc ) return rc;
    printf( "U2C_GetI2cFreq: Frequency=%d\n", freq );
    prev_freq=freq;
    
    rc = U2C_SetI2cFreq( hDevice, U2C_I2C_FREQ_5KHZ );
    printf( "U2C_SetI2cFreq: Freq set to %d\n", U2C_I2C_FREQ_5KHZ );
    
    rc = U2C_GetI2cFreq( hDevice, &freq );
    if( rc ) return rc;
    printf( "U2C_GetI2cFreq: Frequency=%d\n", freq );
    
    rc = U2C_SetI2cFreq( hDevice, prev_freq );
    printf( "U2C_SetI2cFreq: Freq set to %d\n", prev_freq );
    
    // Close 
    U2C_CloseDevice( hDevice ); 
    return rc;
}

